import java.io.*;
import static choco.Choco.*;
import choco.cp.model.CPModel;
import choco.cp.solver.CPSolver;
import choco.kernel.model.Model;
import choco.kernel.solver.Solver;
import choco.kernel.solver.variables.integer.IntDomainVar;

public class DecisionProblem {    
  
  public static void main(String[] args) throws FileNotFoundException, IOException {
      int dueDate   = Integer.parseInt(args[1]);  
      JSSP jssp     = new JSSP(args[0],dueDate);
      Model model   = jssp.model;
      Solver solver = new CPSolver();
      //model.setDefaultExpressionDecomposition(true);
      solver.read(model);

      Decision[] decisions  = jssp.getDecisions();
      int n                 = decisions.length;
      solver.setVarIntSelector(new MinSlackHeuristic(solver,decisions));

      System.out.println("solved: " + solver.solve(false));    
      IntDomainVar makeSpan = solver.getVar(jssp.getMakeSpan());
      System.out.println(makeSpan + " ["+ makeSpan.getInf() +","+ makeSpan.getSup() +"]");
      solver.printRuntimeSatistics();
  }
}
