import java.util.ArrayList;
import choco.kernel.model.Model;

public class Job {
    String id;
    ArrayList<Operation> operations;
    int length;
    Model model;
    
    Job(String id,Model model){
	this.id    = id;
	operations = new ArrayList<Operation>();
	length     = 0;
	this.model = model;
    }
    
    void add(Operation op){
	if (!operations.isEmpty())
	    model.addConstraint(operations.get(length-1).before(op));
	operations.add(op);
	length++;
    }

    Operation get(int i){return operations.get(i);}
    
    public String toString(){
	String s = "(" + id + " ";
	for (int i=0;i<operations.size();i++) s = s + ((Operation)operations.get(i)).toString() + " ";
	return s + ")";
    }
}
