import static choco.Choco.*;
import choco.kernel.model.variables.integer.IntegerVariable;
import choco.kernel.model.constraints.Constraint;

public class Operation {
    String id;
    String resId;
    int duration;
    IntegerVariable start;
    
    Operation(String id,String resId,int duration,int latestStart){
	this.id       = id;
	this.resId    = resId;  // resource id
	this.duration = duration;
	start         = makeIntVar(id,0,latestStart,"cp:no_decision");
    }
    
    public String toString(){ 
	return "{" + id + " " + resId + " " + duration + " [" + start.getLowB() + "," + start.getUppB() + "]}";
    }
    
    Constraint before(Operation op2){
	return geq(op2.start,plus(start,duration));
    }
}
