import java.util.ArrayList;
import static choco.Choco.*;
import choco.cp.model.CPModel;
import choco.kernel.model.Model;
import choco.kernel.model.variables.integer.IntegerVariable;
import choco.kernel.model.constraints.Constraint;

public class Resource {
    String id;
    ArrayList<Operation> operations;
    ArrayList<Decision> decisions;
    Model model;

    Resource(String id,Model model){
	this.id    = id;
	operations = new ArrayList<Operation>();
	decisions  = new ArrayList<Decision>();
	this.model = model;
    }
    
    void add(Operation op){
	int n = operations.size();
	for (int i=0;i<n;i++){
	    Operation op_i = operations.get(i);
	    IntegerVariable decision = makeIntVar("dec_"+ i +","+ n,0,1);
		decisions.add(new Decision(decision,op_i,op));
		Constraint c1 = op_i.before(op);
		Constraint c2 = op.before(op_i);
		Constraint c3 = eq(decision,0);
		Constraint c4 = eq(decision,1);
		Constraint c5 = implies(c3,c1);
		Constraint c6 = implies(c4,c2);
		model.addConstraint(c5);
		model.addConstraint(c6);
	    }
	operations.add(op);
    }
    
    public String toString(){return "Res: " + id + " NoOps: " + operations.size() + " NoDecVars: " + decisions.size();}

}