Operation <: thing(id:string,duration:integer,resource:integer,start:IntVar)

Job <: thing(id:string,operations:list<Operation>)

Resource <: thing(id:string,operations:list<Operation>)

[sched(fname:string,makeSpan:integer) : Problem
 -> let f   := fopen(fname,"r"),
        n   := read(f),
        m   := read(f),
        R   := make_array(m,Resource,Resource()),     // opeartions on resources
        p   := makeProblem(fname,n * m + 1),
        end := Operation(id = "end",duration = 0,
                         resource = -1,start = makeIntVar(p,"end",0,makeSpan))
    in (for j in (1 .. m)
         R[j] := Resource(id = "res" /+ string!(j)),
        for i in (1 .. n)
        let job := Job(id = "job" /+ string!(i))
        in (for j in (1 .. m)
            let op := Operation(),
                x  := makeIntVar(p,"op[" /+ string!(i) /+ "][" /+ string!(j) /+ "]",0,makeSpan),
                k  := read(f) + 1,
                d  := read(f)
            in (op.resource := k,
                op.duration := d,
                op.start := x,
                op.id := "op_" /+ string!(i) /+ "_" /+ string!(j),
                add(job.operations,op),
                add(R[k].operations,op),
                x.hook := tuple(op,R[k])),
            sequenceOperations(p,job),
            sequenceOperations(p,last(job.operations),end)),
        for j in (1 .. m) sequenceResource(p,R[j]),
        fclose(f),
        p)]

[sequenceOperations(p:Problem,op1:Operation,op2:Operation) : void
 -> //[3] sequenceOperations(op.~S >= op.~S + ~S)// op2.id,op1.id,op1.duration,
    post(p,op2.start >= op1.start + op1.duration)]
//
// operation op1 comes before operation op2
//

[sequenceOperations(p:Problem,job:Job) : void
 -> //[2] sequenceOperations(~S) // job.id,
    let m := length(job.operations)
    in for i in (1 .. m - 1)
       let op1 := job.operations[i],
           op2 := job.operations[i + 1]
       in sequenceOperations(p,op1,op2)]

[sequenceResource(p:Problem,op1:Operation,op2:Operation) : void
 -> //[4] sequenceResource(~S,~S) // op1.id,op2.id,
    post(p,(op2.start >= op1.start + op1.duration) or
           (op1.start >= op2.start + op2.duration))]

[sequenceResource(p:Problem,res:Resource) : void
 -> //[3] sequenceResource(~S) // res.id,
    let m := length(res.operations)
    in for i in (1 .. m - 1)
        for j in (i + 1 .. m)
        let op1 := res.operations[i],
            op2 := res.operations[j]
        in sequenceResource(p,op1,op2)]

[make_2D_array(n:integer,m:integer) : array
 -> let M := make_array(n,any,{})
    in (for i in (1 .. n)
         M[i] := make_array(m,any,{}),
        M)]